import itertools
import math

def dist(p1, p2):
    return math.sqrt((p1[0] - p2[0])**2 + (p1[1] - p2[1])**2)

def solve():
    n = int(input())
    points = []
    for _ in range(n):
        x, y = map(int, input().split())
        points.append((x, y))

    min_dist = float('inf')
    for perm in itertools.permutations(points):
        cur_dist = sum(dist(perm[i], perm[i+1]) for i in range(n-1)) #Optimized distance calculation
        min_dist = min(min_dist, cur_dist)

    print(min_dist)

solve()