def lunar_sum(a, b):
    """Computes the sum of two numbers in lunar arithmetic."""
    a_digits = [int(d) for d in str(a)]
    b_digits = [int(d) for d in str(b)]
    max_len = max(len(a_digits), len(b_digits))
    a_digits = [0] * (max_len - len(a_digits)) + a_digits
    b_digits = [0] * (max_len - len(b_digits)) + b_digits
    result_digits = [max(x, y) for x, y in zip(a_digits, b_digits)]
    return int("".join(map(str, result_digits)))


def lunar_product(a, b):
    """Computes the product of two numbers in lunar arithmetic."""
    a_digits = [int(d) for d in str(a)]
    b_digits = [int(d) for d in str(b)]

    result = 0
    for i, digit_a in enumerate(a_digits):
        for j, digit_b in enumerate(b_digits):
            digit_product = min(digit_a, digit_b)
            result = lunar_sum(result, digit_product * (10**(len(a_digits) - 1 - i + len(b_digits) - 1 - j)))

    return result


a = int(input())
b = int(input())

sum_result = lunar_sum(a, b)
product_result = lunar_product(a, b)

print(sum_result, product_result)