import collections

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))
        edges.append((v, u))  # Undirected graph

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    graph = collections.defaultdict(list)
    for u, v in edges:
        graph[u].append(v)

    def bfs(start_node):
        queue = collections.deque([(start_node, 0)])
        visited = {start_node}
        distances = {}
        distances[start_node] = 0

        while queue:
            curr_node, curr_dist = queue.popleft()
            for neighbor in graph[curr_node]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    distances[neighbor] = curr_dist + 1
                    queue.append((neighbor, curr_dist + 1))
        return distances

    protected_warehouses = set()
    for guard_node, guard_range in guards:
        distances_from_guard = bfs(guard_node)
        for warehouse, distance in distances_from_guard.items():
            if distance <= guard_range:
                protected_warehouses.add(warehouse)


    protected_warehouses_list = sorted(list(protected_warehouses))
    print(len(protected_warehouses_list))
    if protected_warehouses_list:
        print(*protected_warehouses_list)

solve()